RTK = {};
local RTK_mt = Class(RTK);


function RTK.prerequisitesPresent(specializations)
    return true;
	end;

function RTK:load(xmlFile)
	self.RTK = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.RTK#index"));
	self.zasieg = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.zasieg#index"));
	self.wlaczona = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wlaczony#index"));
	self.priceForSteerable = 250;
    self.czasswiecenia = 0;
	self.wlaczony = false;

end;

function RTK:delete()
end;

function RTK:onAttach(attacherVehicle)
			setVisibility(self.RTK,false);
end;

function RTK:onDetach()
			setVisibility(self.RTK,true);
end;

function RTK:readStream(streamId, connection)
end;

function RTK:writeStream(streamId, connection)
end;

function RTK:mouseEvent(posX, posY, isDown, isUp, button)
end;

function RTK:keyEvent(unicode, sym, modifier, isDown)
end;

function RTK:update(dt)
	local steerables = table.getn(g_currentMission.steerables);
	local attachables = table.getn(g_currentMission.attachables);

 if self.blisko then
	self.actualPrice = (self.priceForSteerable * steerables);
	self.costs = 0 - (self.actualPrice/24)*((dt*g_currentMission.environment.timeScale)/(1000*60*60)); -- 1h=1000*60*60
	g_currentMission:addSharedMoney(self.costs);
end;
			local nearestDistance = 4; 
			local cx, cy, cz = getWorldTranslation(self.RTK); 
			local bx, by, bz = getWorldTranslation(getCamera());
			local distance = Utils.vector3Length(cx-bx, cy-by, cz-bz);	
			if distance < nearestDistance then
				self.blisko2 = true; 
			else
				self.blisko2 = false; 
			end;
	if  InputBinding.hasEvent(InputBinding.WLACZ) and self.blisko2 then
		self.wlaczony = not self.wlaczony;
	end;

		

	if self.wlaczony then
		setVisibility(self.wlaczona, true);

		self.czasswiecenia = self.czasswiecenia - dt;
		
		if self.czasswiecenia < 1500 and self.czasswiecenia > 1100 then
			setVisibility(self.zasieg, true);
		elseif self.czasswiecenia <= 1100 and self.czasswiecenia > 1 then
			setVisibility(self.zasieg, false);
		else
			self.czasswiecenia = 1499;
		end;
		
		local px, py, pz = getWorldTranslation(self.RTK); 
		local nearestDistance = 4000; 
			
		for k,v in pairs(g_currentMission.steerables) do
			local vx, vy, vz = getWorldTranslation(v.rootNode);
			local distance = Utils.vector2Length(px-vx, pz-vz);
			if distance < nearestDistance then
				self.blisko = true; 
			else
				self.blisko = false; 
			end; 
		end;
	else
		setVisibility(self.wlaczona, false);
	end;

end;

function RTK:updateTick(dt)
end;

function RTK:draw()
end;

function RTK:addOperatingTime(addTime)
end;

function RTK:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)	
  if not resetVehicles then
	local roboczy = getXMLBool(xmlFile, key.."#wlaczony");
	if roboczy then
	   self.wlaczony = true;
	end;
    return BaseMission.VEHICLE_LOAD_OK;
 end;
end;

function RTK:getSaveAttributesAndNodes(nodeIdent)
   local attributes = 'wlaczony="'..tostring(self.wlaczony)..'"';
   return attributes, nil;
end;